package config

import (
	"runtime/debug"

	"github.com/sirupsen/logrus"
)

var (
	BuildInfo *debug.BuildInfo
	Version   string
)

func init() {
	var ok bool
	BuildInfo, ok = debug.ReadBuildInfo()
	if !ok {
		logrus.Error("failed to read build info")
		return
	}

	if Version == "" {
		for _, setting := range BuildInfo.Settings {
			if setting.Key == "vcs.revision" {
				Version = setting.Value
				break
			}
		}

		if Version == "" {
			Version = "development"
		}
	}
}
